/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package memegene;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSplitPane;
import javax.swing.JTextField;

/**
 *
 * @author Mauricio Alarcón M.
 * @author Felipe Urra A.
 */
public class GMApp {

    /**Crea un MemeGeneFrame.
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        MemeGeneFrame marco = new MemeGeneFrame();
        marco.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        marco.setVisible(true);
    }

}

/**
 * Esta clase corresponde a la interfaz inicial de la aplicacion, donde se setea la funcion
 * objetivo de los algoritmos, y sus parametos, además de la configuración de los algoritmos.
 * Contiene además un gráfico el cual muestra el resultado de los algoritmos a través de sus
 * iteraciones
 *
 * @author Mauricio Alarcon M.
 * @author Felipe Urra A.
 */

class MemeGeneFrame extends JFrame{

    /**Algoritmo genético a utilizar*/
    MAFunction ma;
    /**Algoritmo genético a utilizar*/
    GAFunction ga;
    /**Panel el cual contiene un gráfico, para efectos de mostrar los resultados de los
     * algoritmos a través de sus interaciones.
     */
    GPanel panelGrafico;
    /**
     * Etiquetas de la interfaz
     */
    JLabel funcion,rangoDesde,hasta,precisionL,MaxMin;
    /**
     * Campos de texto para ingresar los distintos parámetros
     */
    JTextField funcionC,desdeC,hastaC,precisionC;
    /**
     * Parametros de los algoritmos
     */
    float probVict,probMutac,precision;
    /**
     * Parametros de los algoritmos
     */
    int poblacion,generaciones;
    /**
     * Parametros de los algoritmos
     */
    int seleccion;

    /**Paneles contenedores del gráfico y los parametros de entrada*/
    JPanel grafico,parametros;
    /**Divisor que contiene los paneles "parametros" y "grafico"*/
    JSplitPane contenedor;
    /**Combobox que decide si la funcion se maximizará o minimizará*/
    JComboBox MaxMinC;
    /**Menu el cual permite configurar */
    BarraMenu menu;
    /**Panel contenedor de las etiquetas y campos de entrada*/
    JPanel funcionPanel,rangoDesdePanel,hastaPanel,precisionPanel,MaxMinPanel;
    /**Panel contenedor del boton de inicio del algoritmo*/
    JPanel botonPanel;
    /**Botón de inicio*/
    JButton botonGo;
    
    /**
     * Constructor
     */
    MemeGeneFrame(){

      setTitle("Algoritmos Genéticos y Meméticos");
      setSize(DEFAULT_WIDTH, DEFAULT_HEIGHT);
      this.setLocationByPlatform(true);
      //Listeners...uno para el boton Go!, y otro para el de configuración.
      

      //Los paneles contenedores      
      //contenedor = new JPanel(new GridLayout(1,2));
      
      grafico = new JPanel(new FlowLayout(FlowLayout.LEFT));
      parametros = new JPanel(new GridLayout(6,1));

      funcionPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
      rangoDesdePanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
      hastaPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
      botonPanel = new JPanel(new FlowLayout(FlowLayout.CENTER));
      precisionPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
      MaxMinPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));

      botonGo = new JButton("Go!");
      //agregar los labels y los jtextfield
      funcion    = new JLabel("Función objetivo:");
      rangoDesde = new JLabel("       Rango desde:");
      hasta      = new JLabel("                     hasta:");
      precisionL = new JLabel("              Precision:");
      MaxMin     = new JLabel("                       Tipo:");
      JLabel nada = new JLabel("  ");
      funcionC = new JTextField(10);      
      desdeC = new JTextField(10);
      hastaC = new JTextField(10);
      precisionC = new JTextField(10);
      String[] lista = {"Minimizacion","Maximizacion"};
      MaxMinC = new JComboBox(lista);

      panelGrafico = new GPanel(200,"Algoritmos v/s Generaciones","Genético/Memético","Generaciones");
      
      ListenerBotones lb = new ListenerBotones(this);
      ListenerGo lg = new ListenerGo(this,panelGrafico);

      botonGo.addActionListener(lg);
      menu = new BarraMenu(lb); //hay que entregarle los listeners!
      setJMenuBar(menu);

      funcionPanel.add(funcion);
      funcionPanel.add(funcionC);
      parametros.add(funcionPanel);
      rangoDesdePanel.add(rangoDesde);
      rangoDesdePanel.add(desdeC);
      parametros.add(rangoDesdePanel);
      hastaPanel.add(hasta);
      hastaPanel.add(hastaC);
      parametros.add(hastaPanel);
      botonPanel.add(botonGo);
      precisionPanel.add(precisionL);
      precisionPanel.add(precisionC);
      MaxMinPanel.add(MaxMin);
      MaxMinPanel.add(MaxMinC);
      parametros.add(precisionPanel);
      parametros.add(MaxMinPanel);
      parametros.add(botonPanel);
      //grafico.add(panelGrafico);
      //parametros.add(nada);parametros.add(nada);
      contenedor = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,true,parametros,panelGrafico);
      contenedor.setOneTouchExpandable(true);
      getContentPane().add(contenedor);
      //contenedor.add(parametros);

      //contenedor.add(panelGrafico);
      botonGo.setEnabled(false);
      //add(contenedor);
      //agregar la barra de menu, el listener del menu.
      //agregar el boton para correr el genético, crear un listener para eso
      //agregar el gráfico


   }
   public static final int DEFAULT_WIDTH = 800;
   public static final int DEFAULT_HEIGHT = 400;
}
