/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package memegene;

/**
 * Hebra que corre el método "ejecutar" de un objeto que extienda de GA.
 *
 * @author Mauricio Alarcon M.
 * @author Felipe Urra A.
 */
public class HebraGa implements Runnable{

    /**
     * Algoritmo genético a usar
     */
    GAFunction ga;
    /**
     * Algoritmo memético a usar
     */
    MAFunction ma;
    /**
     * Numero de generaciones y el tipo de seleccion a utilizar, definido en una constante estatica
     * de GA.
     */
    int generaciones,seleccion;
    /**
     * Probabilidad de victoria en caso de haberse elegido torneo.
     */
    float probVict;
    /**
     * booleano que es verdadero cuando se ejecuta un algoritmo memético
     */
    boolean gm;

    /**Constructor
     *
     * @param ga    El algoritmo memético o genético a utilizar
     * @param generaciones Numero de iteraciones de los algoritmos
     * @param seleccion Tipo de seleccion
     * @param probVict Probabilidad de victoria del tipo de seleccion "torneo"
     * @param gm booleano, true si corresponde a un algoritmo genético.
     */
    HebraGa(GA ga,int generaciones,int seleccion, float probVict,boolean gm){
        System.out.println("hebra papi::"+generaciones);
        this.generaciones = generaciones;
        this.seleccion = seleccion;
        this.probVict = probVict;
        this.gm = gm;
        if(gm==true){
            this.ga = (GAFunction)ga;
        }else{
            this.ma = (MAFunction)ga;
        }
    }

    /**
     * Metodo que ejecuta el algoritmo genético
     */
    @Override
    public void run(){
        if(gm == true){
            this.ga.ejecutar(this.generaciones,this.seleccion,this.probVict);
            this.ga.print();
        }else{
            this.ma.ejecutar(this.generaciones,this.seleccion,this.probVict);
            this.ma.print();
        }
    }
}
