/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package memegene;

import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**Listener que se ejecuta al presionar el botón "configurar" del menú de "inicio" de la interfaz
 * inicial de la aplicación
 *
 * @author Mauricio Alarcón M.
 * @author Felipe Urra A.
 */
public class ListenerBotones implements ActionListener{

    /**
     * Referencia al frame padre
     */
    MemeGeneFrame padre;
    /**
     * Objeto dialogo, el cual crea un dialogo modal
     */
    Dialogo d;
    /**
     * Constructor
     * @param padre Referencia al nodo padre
     */
    ListenerBotones(MemeGeneFrame padre){
        this.padre = padre;
    }

    /**
     * Crea un cuadro de dialogo modal para ingresar datos de configuración de los algoritmos
     * @param e evento de presionar el botón "configurar"
     */
    public void actionPerformed(ActionEvent e){

        //Listener de configuracion
        if(d == null)
            d = new Dialogo(this.padre);
        d.setVisible(true);
        padre.generaciones = Integer.parseInt(d.generacionesC.getText());       
        padre.poblacion = Integer.parseInt(d.poblacionC.getText());
        padre.probMutac = Float.parseFloat(d.probMutC.getText());
        if(d.probVict.getText() == null){
            padre.probVict = Float.parseFloat(d.probVict.getText());
        }
        padre.seleccion = d.seleccionarC.getSelectedIndex();        

    }

}

/**
 * Clase que crea un cuadro de dialogo modal, para ingresar los datos de configuración de los algoritmos
 *
 * @author Mauricio Alarcón M.
 * @author Felipe Urra A.
 */
class Dialogo extends JDialog{

    /**
     * Paneles de la ventana
     */
    JPanel contenedor,poblacionP,generacionesP,probVictP,probMutP,seleccionarP,aceptarP;
    /**
     * etiquetas de la ventana
     */
    JLabel poblacion,generaciones,probVict,probMut,seleccionar;
    /**
     * ComboBox para seleccionar el tipo de seleccion que utilizarán los algoritmos
     */
    JComboBox seleccionarC;
    /**
     * Cuadro de texto para ingresar datos de configuración del algoritmos
     */
    JTextField poblacionC,generacionesC,probVictC,probMutC;
    /**
     * Boton para aceptar los cambios generados en el cuadro de configuración
     */
    JButton aceptar;
    /**
     * Boton para cancelar los cambios.
     */
    JButton cancelar;
    //jtext,combo (agregarle el listener)

    //boton

    /**
     * Constructor
     * @param padre Referencia al frame padre.
     */
    Dialogo(final MemeGeneFrame padre){
        super(padre, true);
        this.setSize(200,350);
        this.setLocationRelativeTo(padre);
        this.setTitle("Configuracion Algoritmos");

        contenedor = new JPanel(new GridLayout(6,1));
        poblacionP = new JPanel(new FlowLayout(FlowLayout.LEFT));
        generacionesP = new JPanel(new FlowLayout(FlowLayout.LEFT));
        probMutP = new JPanel(new FlowLayout(FlowLayout.LEFT));
        probVictP = new JPanel(new FlowLayout(FlowLayout.LEFT));
        seleccionarP = new JPanel(new FlowLayout(FlowLayout.LEFT));
        aceptarP = new JPanel(new FlowLayout(FlowLayout.RIGHT));
        
        poblacion = new JLabel("Poblacion: ");
        poblacionC = new JTextField(10);
        poblacionP.add(poblacion);poblacionP.add(poblacionC);

        generaciones = new JLabel("Generaciones: ");
        generacionesC = new JTextField(10);
        generacionesP.add(generaciones);generacionesP.add(generacionesC);

        probVict = new JLabel("Probabilidad de Victoria: ");
        probVictC = new JTextField(10);
        probVictP.add(probVict);probVictP.add(probVictC);

        probMut = new JLabel("Probabilidad de Mutacion: ");
        probMutC = new JTextField(10);
        probMutP.add(probMut);probMutP.add(probMutC);

        seleccionar = new JLabel("Tipo de Seleccion: ");
        String[] lista = {"Elite","Ranking","Torneo"};
        seleccionarC = new JComboBox(lista);
        
        seleccionarC.addActionListener(new ActionListener(){       

            public void actionPerformed(ActionEvent ev){                
                JComboBox combo = (JComboBox)(ev.getSource());
                if(((String)combo.getSelectedItem()).equals("Torneo")){
                    probVictC.setEnabled(true);
                    repaint();
                }else{
                    probVictC.setEnabled(false);
                    repaint();
                }
            }
        }
        );
        
        seleccionarP.add(seleccionar);seleccionarP.add(seleccionarC);
        aceptar = new JButton("Aceptar");
        aceptar.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent arg0) {
                padre.botonGo.setEnabled(true);
                setVisible(false);
            }
        });
        cancelar = new JButton("Cancelar");
        cancelar.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent arg0) {
                setVisible(false);
            }
        });
        aceptarP.add(aceptar);
        aceptarP.add(cancelar);

        this.probVictC.setEnabled(false);

        contenedor.add(poblacionP);
        contenedor.add(generacionesP);
        contenedor.add(probMutP);
        contenedor.add(seleccionarP);
        contenedor.add(probVictP);
        contenedor.add(aceptarP);

        getContentPane().add(contenedor);
        
    }
}
