/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package memegene;

/**Clase que representa un algoritmo Memético genérico, abstracto
 *
 * @author Mauricio Alarcón M.
 * @author Felipe Urra A.
 */

public abstract class MA extends GA{

    /**
     * constructor
     * @param individuos numero de soluciones a competir en el algoritmo memético
     * @param pmut probababilidad de mutación
     * @param min boolean que es verdadero si es un algoritmo de minimización
     */
    MA(int individuos,float pmut,boolean min){
        super(individuos,pmut,min);        
    }

    /**
     * Metodo abstracto, define la forma en que se realiza una búsqueda local en el algoritmo memético particular
     */
    public abstract void busquedaLocal();

    /**
     * Ejecuta el algoritmo memético
     * @param iteraciones   numero de iteraciones del algoritmo
     * @param idSeleccion tipo de selccion, definida como constante estatica en GA.
     * @param probabilidadTorneo Probabilidad de elegir al indiviuo de mayor fitness para el tipo de
     * seleccion "tournament"
     */
    @Override
    public void ejecutar(int iteraciones,int idSeleccion, float probabilidadTorneo){

        for(int i=0; i < iteraciones;i++){
            this.fitness();

            switch(idSeleccion){
                case 0:
                       this.elite();
                       break;
                case 1:
                       this.tournament(probabilidadTorneo);
                       break;
                case 2:
                       this.ranking();

            }
            this.mutacion();
            this.busquedaLocal();
            //this.print();
        }
        this.fitness();
//        this.print(); //informe final
    }



}
